<?php

include_once(dirname(__FILE__).'/formElement.interface.php');

class basicElement implements formElement{
	
	private $type, $name, $label, $defaultValue,
	        $value, $extra, $validator, $loaded = false;
	        
    public function __construct($type, $name, $label = '', $defaultValue = '', $extra = '', $validator = null){

		$allowedTypes = array('text','password','checkbox','radio',
    	                    'file','hidden','image','reset','textarea',
                            'select','button','submit');
    	if(strlen($name) > 0 &&
    	   in_array(strtolower($type), $allowedTypes)){
    	   	$this->type = strtolower($type);
    		$this->name = $name;
    		$this->label = $label;
    		$this->defaultValue = $defaultValue;
    		$this->extra = $extra;
    		$this->validator = $validator;

			$this->load();
    	} else {
    		// erreur	
    	}
    }
    
    public function load(){
    	if(array_key_exists($this->name, $_GET)){
    		$this->value = $_GET[$this->name];
    		$this->loaded = true;
    	} elseif(array_key_exists($this->name, $_POST)) {
    		$this->value = $_POST[$this->name];
    		$this->loaded = true;
    	} else {
    		$this->value = $this->defaultValue;
    	}
    }
    
    public function show(){
	   	echo "<div class=\"formElement\">\n";
    	if($this->isValid() !== true)
    		$this->showError();
    	
   		echo "\t<label for=\"$this->name\">",($this->label == '')?'&nbsp;':$this->label,'</label>';
    		
    	echo '<span class="formInput">';
    	if($this->type == 'textarea')
    		echo '<textarea name="',$this->name,'" ',$this->extra,'>',$this->value,'</textarea>';
    	else 
    	    echo '<input type="',$this->type,'" id="',$this->name,'" name="',$this->name,'" value="',$this->value,'" ',$this->extra,' />';
    	echo "</span>\n";
    	echo "</div>\n\n";
    }
    
    public function showError(){
        echo "\t<span class=\"formError\">",$this->validator->getErrorMessage(),"</span>\n";	
    }
    
    public function isValid(){
    	if($this->loaded && isset($this->validator)){
    		return $this->validator->validate($this->value);
    	}
    	else
    		return true;
    }
    
    public function debug(){
    	echo '<pre>';
    	var_dump($this);
    	echo '</pre>';	
    }
}

?>