<?php
include_once(dirname(__FILE__).'/calendarDay.class.php');

/**
 * calendar
 * 
 * @author Maxime Dupuis
 */
class calendar {

	public $days = array();
	private $year, $month, $day , $events = array(),
			$dayNames = array('Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi'),
			$monthNames = array(1=>'Janvier','Février','Mars','Avril','Mai','Juin','Juillet','Août','Septembre','Octobre','Novembre','Décembre'),
			$dayLength = 3,
			$name;

	/**
	 * __construct
	 */
	public function __construct($year, $month = 1, $day = 1, $extraParams = array()) {
		$this->year = $year;
		$this->month = $month;
		$this->day = $day;
    	
   		/* extra */
		foreach($extraParams as $name => $value)
   			$this->$name = $value;

		/* days initialize */
		$numDays = date('t', mktime(0, 0, 0, $month, $day, $year));
		for($i = 1; $i <= $numDays; ++$i){
			$this->days[$i] = new calendarDay($i);
		}

		/* DEBUG 
		var_dump($this->days);
		echo '<b>numdays :: ',$numDays,'</b><br />';
		*/
	}
    
	/**
	 * loadEvents
	 */
	public function loadEvents($userNo, $eventInstance){
		/** LOAD EVENTS FROM THE DATABASE **/
		foreach($this->days as $num => $day){
			$tempDate = str_pad($num,2,'0',STR_PAD_LEFT).'-'.str_pad($this->month,2,'0',STR_PAD_LEFT).'-'.$this->year;
			$day->events = $eventInstance->findByDate($tempDate);
		}
	}
	
	/**
	 * display
	 * 
	 * old - replaced by generate() and display only echoes what generate() returns
	 */
	/**public function display($preDay='', $afterDay=''){
		$ret = '<table class="calendar"';
		if(isset($this->name))
			$ret .= ' id="'.$this->name.'"><tr>';
		else
			$ret .= '><tr>';
		
		foreach($this->dayNames as $day){
			$ret .= '<th class="calendarDayName">';
			if($this->dayLength <= 3)
				$ret .= substr($day,0,$this->dayLength);
			else
				$ret = $day;
			$ret .= '</th>';
		}
		$ret .= '</tr><tr>';
		
		$dayNum = date('d',mktime(0,0,0, $this->month+1, 0, $this->year));
		$dayCurr = 1;
		$weekDayFirst = date('w',mktime(0,0,0, $this->month, $this->day, $this->year));
		$weekDay = 0;
		
		/* empty days 
		while($weekDay < $weekDayFirst){
			$ret .= '<td class="calendarEmptyDay">&nbsp;</td>';
			++$weekDay;
		}

		/* calendar 	
		while($dayCurr <= $dayNum){
			if($weekDay % 7 == 0)
				$ret .= '</tr><tr>';
				
			$ret .= '<td class="calendarDay">'.$preDay.$dayCurr.'.';
			if(array_key_exists($dayCurr, $this->events)){
				$event = $this->events[$dayCurr];
				$event->display();
			}
			$ret .= $afterDay.'</td>';

			
			++$dayCurr;
			++$weekDay;
		}
		
		while($weekDay % 7 != 0){
			$ret .= '<td class="calendarEmptyDay">&nbsp;</td>';
			++$weekDay;
		}
		
		$ret .= '</tr></table>';
		return $ret;
	}**/
	public function display(){
		echo $this->generate();	
	}

	public function generate(){
		$ret = '<table class="calendar"';
		if(isset($this->name))
			$ret .= ' id="'.$this->name.'"';
		$ret .= '><tr><th colspan="7">'.$this->monthNames[date('n', mktime(0,0,0, $this->month, $this->day, $this->year))].' '.$this->year.'</th></tr><tr>';
		
		foreach($this->dayNames as $day){
			$ret .= '<th class="calendarDayName">';
			if($this->dayLength <= 3)
				$ret .= substr($day,0,$this->dayLength);
			else
				$ret .= $day;
			$ret .= '</th>';
		}
		$ret .= '</tr><tr>';
		
		$dayNum = date('d',mktime(0,0,0, $this->month+1, 0, $this->year));
		$dayCurr = 1;
		$weekDayFirst = date('w',mktime(0,0,0, $this->month, 1, $this->year));
		$weekDay = 0;
		
		/* empty days */
		while($weekDay < $weekDayFirst){
			$ret .= '<td class="calendarEmptyDay">&nbsp;</td>';
			++$weekDay;
		}

		/* calendar */		
		while($dayCurr <= $dayNum){
			if($weekDay % 7 == 0)
				$ret .= '</tr><tr>';

			$day = $this->days[$dayCurr];

			$ret .= '<td class="calendarDay">'.$day->generate().'</td>';
			
			++$dayCurr;
			++$weekDay;
		}
		
		while($weekDay % 7 != 0){
			$ret .= '<td class="calendarEmptyDay">&nbsp;</td>';
			++$weekDay;
		}
		
		$ret .= '</tr></table>';
		return $ret;
	}
}

/*** TESTING 
$cal = new calendar(date('Y'), date('m'), date('d'));
$cal->display();
***/
?>