<?php
/**
 * form
 * 
 * Generates web forms
 */

class form {

	private $fields;
	private $name, $method, $action, $extra;
	private $lastField;

    public function __construct($name, $method = 'post', $action = '', $extra = ''){
    	if(strlen($name) > 0 &&
    	   in_array(strtolower($method), array('post','get'))){
    		$this->name = $name;
    		$this->method = strtolower($method);
    		$this->action = $action;
    		$this->extra = $extra;
    	} else {
    		// error
    	}
    }

    public function show(){
    	echo '<form name="',$this->name,'" method="',$this->method,'" ',
             'action="',$this->action,'" ',$this->extra,">\n";

    	foreach($this->fields as $field)
    		$field->show();

    	echo "</form>\n";
    }

    public function __get($elementName){
    	if(array_key_exists($elementName, $this->fields))
    		return $this->fields[$elementName];
    	return false;
    }

    public function __set($elementName, $formElement){
    	$implementations = class_implements($formElement);
    	if(in_array('formElement', $implementations)){
    		$this->fields[$elementName] = $formElement;
    		return true; 
    	}
    	return false;
    }
    
    public function isSent(){
    	if($this->method == 'post')
    		return (count($_POST) >= count($this->fields));
	   	elseif($this->method == 'get')
    		return (count($_GET) >= count($this->fields));
    	return false;
    }
    
    public function isValid(){
    	foreach($this->fields as $field):
    		if($field->isValid() !== true)
    			return false;
    	endforeach;
    	return true;
    }
    
    public function debug(){
    	foreach($this->fields as $field)
    		$field->debug();
    }
}
?>