<?php
/**
 * functionValidator
 *
 * validate something against an existing function
 */

class functionValidator{

	protected $func, $errorMessage;

    public function __construct($functionName, $errorMessage){
    	if(!function_exists($functionName))
    	    throw new exception('The specified function does not exists :: '. __FILE__ . ' @ Line '.__LINE__);
    	
    	$this->func = $functionName;
    	$this->errorMessage = $errorMessage;
    }

    public function validate($string){
    	$tmp = $this->func;
    	return (bool)$tmp($string);
    }
    
    public function getErrorMessage(){
    	return $this->errorMessage;	
    }
}

/*** TESTING
try{
	$validator = new functionValidator('ctype_digit');
	if($validator->validate('1223'))
		echo 'OUAIS';
	else
		echo 'NAON';
} catch(exception $e) {
	echo $e->getMessage();
}
***/
?>