<?php

/**
 * regexValidator
 * 
 * Takes a PCRE regex as the first argument and
 * can test wheter a String is valid against
 * that regex.
 * 
 * @author Maxime Dupuis
 */

class regexValidator{

	protected $regexStr, $errorMessage;

    public function __construct($regex, $errorMessage = 'Input required'){
		$this->errorMessage = $errorMessage;
    	$this->regexStr = $regex;
    }

    public function validate($string){
    	return (preg_match($this->regexStr, $string) > 0);
    }
    
    public function getErrorMessage(){
    	return $this->errorMessage;	
    }
}

/*** TESTING
$val = new regexValidator('/(abc){1}/');
if($val->validate('abcdef'))
	echo 'Yeah';
else
	echo 'No';
***/
?>