<?php
/**
 * socket
 * 
 * handles a socket connection, data sending and
 * data retrieving
 */
class socket{

	private $sock;

    public function __construct($host = 'localhost', $port, $timeout = 5, $protocol='', $permanant = false){
    	$errno = 0;
    	$errstr = '';
    	
    	if($permanant === true)
    		$this->sock = pfsockopen($host, $port, $errno, $errstr, $timeout);
    	else
	   		$this->sock = fsockopen($host, $port, $errno, $errstr, $timeout);
 	
    	if($errno != 0){
    		unset($this->sock);
    		throw new exception('Error while creating socket :: #'.$errno.' - '.$errstr);
    	} else {
		   	socket_set_timeout($this->sock, 0, 25000);
    	}
    }
    
    public function send($data){
    	return fwrite($this->sock, $data."\r\n", strlen($data)+2);
    }
    
    public function retrieve(){
    	$return = $line = '';
   	
		if(is_resource($this->sock)){
			//while(strpos($return, "\r\n") === false || substr($line,3,1) !== ' '){
			while(strpos($line, "\r\n") === false || substr($line,3,1) !== ' '){
				$line    = fgets($this->sock, 1024);
				$return .= $line;
			}
			return $return;
		}
		return false;
    }
}
?>