<?php
/**
 * User class
 */

class user{

	const _INSERT_ = '
	INSERT INTO usagers (nom, courriel, password)
			VALUES (?,?,?);
	';
	
	const _FIND_ = '
	SELECT id, nom, courriel FROM usagers WHERE nom = ? AND password = ?
	';
	
	private $dbh;
	
	public function __construct($dbh){
		$this->dbh = $dbh;
	}

	/**
	 * findByNameAndPassword
	 * 
	 * Used for logging in users so they can access to their own area.
	 * @return	boolean	Returns true if a user has been found with the parameters passed to the function
	 */
	public function findByNameAndPassword($userName, $password){
			$found = $this->dbh->prepare(self::_FIND_);
			if($found->execute(array($userName, $password)))
				if($user = $found->fetch(PDO::FETCH_NUM) )
					return $user;
			
			return false;
	}
	
	public function add($nom, $courriel, $password){
		$newUser = $this->dbh->prepare(self::_INSERT_);
		$ins = $newUser->execute(array($nom, $courriel, $password));
		
		return ($ins == 1);
	}

}

/** TEST

$dbPath = 'bdtest.sq3';

$table = <<< END
CREATE TABLE usagers IF NOT EXISTS(
	"id"		INTEGER			PRIMARY KEY	AUTOINCREMENT,
	"nom" 	varchar(30)		NOT NULL,
	"courriel"	varchar(50)	NOT NULL,
	"password"	varchar(20)	NOT NULL
);
END;

$dbh = new PDO('sqlite:'.$dbPath);
$dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
//$dbh->query($table);

$usager = new user($dbh);
//$usager->add('yo', 'yo@yo.com', 'yo');
//$usager->add('ya','ya@ya.com','ya');
if ($usager->findByNameAndPassword('ya','ya') )
	echo 'trouv�';
else
	echo 'non trouv�';
*/
?>
