<?php
/**
 * xhtmlPage
 * 
 * Template class which outputs XHTML
 */

class xhtmlPage {
	
	const __SECTION_REGEX__ = '/\{{3}[_a-zA-Z]+\}{3}/U';
	
	private $sections, $template, $ret;
	private $sectionsValues = array();

    public function __construct() {
    	
    }
    
    public function loadTemplateFile($filepath){
    	if(!file_exists($filepath))
    		throw new exception('The template file doesn\'t exists @ '.__FILE__.' line '.__LINE__);
    	
    	$this->template = file_get_contents($filepath);
    	preg_match_all(self::__SECTION_REGEX__, $this->template, $this->sections);
    	$this->sections = $this->sections[0];
    	
    	foreach($this->sections as $k => $section)
    		$this->sections[$k] = str_replace(array('{','}'), '', $section);
    }

	public function setSection($sectionName, $value){
		if(!in_array($sectionName, $this->sections))
			throw new exception('The specified section (<b>'.$sectionName.'</b>) isn\'t present in the template @ '.__FILE__.' line '.__LINE__);
			
		$this->sectionsValues[$sectionName] = $value;
	}
    
    public function display(){
    	$this->ret = $this->template;
    	
    	foreach($this->sectionsValues as $k => $v)
    		$this->ret = str_replace('{{{'.$k.'}}}', $v, $this->ret);
    	
	   	//eturn iconv('', $this->charset, $this->ret);
	   	return $this->ret;
    }
    
    public function getSections(){
    	return $this->sections;
    }
    
    public function debug(){
    	var_dump($this->template);
    	var_dump($this->sections);
    }
}
?>