<?php
/**
 * __autoload
 * 
 * Autoload needed classes so I don't have to do 10000 includes
 */
function __autoload($className){
	$className = str_replace('_','/',$className);
	include_once(APPPATH.'classes/'.strtolower($className).'.class.php');
}

/**
 * stripAllSlashes
 * 
 * Strips slashes from all the strings contained in an array
 */
function stripAllSlashes($array){
	if(!is_array($array))
		return stripslashes($array);
	else
		return array_map('stripAllSlashes', $array);
}

/**
 * stripFormSlashes
 * 
 * Strips the magic quotes if magic_quotes_gpc is ON
 */
function stripFormSlashes(){
	if(get_magic_quotes_gpc()){
		$_GET = stripAllSlashes($_GET);
		$_POST = stripAllSlashes($_POST);	
	}	
}

/**
 * loadPage
 * 
 * returns the output of a file by using include and output buffering
 */
function loadPage($fileName){
	ob_start();
	include($fileName);
	$ret = ob_get_contents();
	ob_end_clean();
	return $ret;
}
?>
