<?php
include(dirname(__FILE__).'/default.func.php');
include(dirname(__FILE__).'/config.php');

session_start();

$_SESSION['y'] = (array_key_exists('y',$_GET)) ? $_GET['y'] : date('Y');
$_SESSION['m'] = (array_key_exists('m',$_GET)) ? $_GET['m'] : date('n');
$_SESSION['d'] = (array_key_exists('d',$_GET)) ? $_GET['d'] : date('j');

/*
// Saving the page in session
if(@array_key_exists('page', $_GET))
	$_SESSION['page'] = $_GET['page'];
elseif(@array_key_exists('page',$_SESSION))
	$_GET['page'] = $_SESSION['page'];
else
	$_GET['page'] = '';
*/

setlocale(LC_ALL, 'fr_FR'); // Useful ?
// as in calendar.class.php
$monthNames = array(1=>'janvier','février','mars','avril','mai','juin','juillet','août','septembre','octobre','novembre','décembre');

try{
	// Stripping the user's data if necessary
	stripFormSlashes();
	
	/** Database */
	$dbPath = 'magenda.sq3';

	$dbh = new PDO('sqlite:'.$dbPath);
	$dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	
	$output = new xhtmlPage();
	$output->loadTemplateFile(APPPATH.'tpl/3lines.tpl.php');

	$date = '<h4 id="date">Nous sommes le '.date('j').' '.substr($monthNames[date('n')],0,3).'. '.date('Y'). '</h4>';

/* Content */
	// Calendar
	$cal = new calendar(date('Y'), date('m'), date('d'), array('dayLength'=>1));
	$cal->days[date('j', mktime())]->style = array('background-color: #c00');
	$calendar = $cal->generate();
		
	// Events
	$eventFinder = new event($dbh);
	$eventsDuJour = $eventFinder->findByDate(date('d-m-Y'));
	$horaire = '<h3>Votre agenda pour aujourd\'hui</h3>' .
			'<ul style="margin:0px;">';
	if(count($eventsDuJour) == 0)
		$horaire .=	'<li>Rien</li>';
		
	else{
		foreach($eventsDuJour as $event)
			$horaire .= '<li><a href="index.php?page=showEvent&amp;eventId='.$event->id.'">'.$event->titre.'</a> ['.$event->heureDebut.'-'.$event->heureFin.']</li>';
	}
	$horaire .= '</ul>';

	// Menu and agenda
	if(@!array_key_exists('userId',$_SESSION)){
		// if user is not connected
		$menu = '';
		$horaire = $description;
	} else {
		// if he is
		$menu = '<a href="index.php?page=calendar">Voir vos événements</a> &nbsp; | &nbsp; <a href="index.php?page=ajoutEvent">Ajouter un événement</a> &nbsp; | &nbsp; <a href="index.php?page=deconnexion">Déconnexion</a>';
	}
	
	// Content - central section
	switch(@$_GET['page']){
		case 'inscription':
			$content = loadPage(APPPATH.'inscription.php'); 
			break;
		case 'connexion':
			$content = loadPage(APPPATH.'connect.php');
			break;
		case 'deconnexion':
			session_destroy();
			session_start();
			header("Location: index.php");
			break;
		case 'ajoutEvent':
			if(@array_key_exists('userId', $_SESSION))
				$content = loadPage(APPPATH.'ajoutEvent.php');
			break;
		case 'showEvent':
			if(@array_key_exists('userId', $_SESSION))
				$content = loadPage(APPPATH.'showEvent.php');
			break;
		case 'modifyEvent':
			if(@array_key_exists('userId', $_SESSION))
				$content = loadPage(APPPATH.'modifyEvent.php');
			break;
		case 'deleteEvent':
			if(@array_key_exists('userId',$_SESSION))
				$content = loadPage(APPPATH.'deleteEvent.php');
			break;
		case 'calendar':
			if(@array_key_exists('userId', $_SESSION))
				$content = loadPage(APPPATH.'calendrier.php');
			break;
	}
	
	// in case a page wasn't loaded
	if(!isset($content) || strlen($content) == 0){
		if(!@array_key_exists('userId',$_SESSION))	// if the user isn't connected
			$content = '';				// we display nothing
		else							// and if he is
			$content = loadPage(APPPATH.'calendrier.php');	// we display the calendar	
	}
/* /Content */
	
	/* CSS INFORMATIONS */
	if(!isset($css))
		$css = '';
	/* /CSS INFORMATIONS */

	/* Displaying the page */
	// Setting the sections
	foreach($output->getSections() as $sectionName){
		$sectionName = strtolower($sectionName);
		if( isset($$sectionName) )
			$output->setSection(strtoupper($sectionName), $$sectionName);
		}
	// Generating and echoing
	echo $output->display();	
	/* /Displaying the page */
} catch(exception $e){
	echo 'Error in ', $e->getFile(), ' at line ', $e->getLine(), " :: <br />\n",
		$e->getMessage(),"<br /><br />\n\n";
}
?>