<?php
if(session_id() == '')
	die();

global $css, $dbh, $_SMTP;
$css .= '@import "forms.css";';

if(@array_key_exists('eventId',$_GET)){
	$eventFinder = new event($dbh);
	$event = $eventFinder->findById($_GET['eventId']);
	
	if($event !== false && $event->userId == $_SESSION['userId']){

/****************************************/

/* validators */
$nonNull = new regexValidator('/^(.+)$/','Vous devez entrer quelque chose', 'Veuillez entrer quelque chose');
$dateVal = new regexValidator('/^[0-9]{2}-{1}[0-9]{2}-{1}[0-9]{4}$/', 'Format de date invalide');
$hourVal = new regexValidator('/^[0-9]{1,2}:{1}[0-9]{2}$/', 'Format d\'heure invalide');
$email = new regexValidator('/^(.+)@{1}(.+)\.{1}([A-Za-z]){2,3}$/');

$form = new form('ajoutEvent','post',PAGE);
$form->id = new basicElement('hidden','id','',$_GET['eventId'],'');
$form->title = new basicElement('text','title','Nom de l\'événement : ',$event->titre,'',$nonNull);
$form->desc = new basicElement('textarea','desc','Description : ',$event->description,'');
$form->date = new basicElement('text','date','Date : <br />(format dd-mm-yyyy)',$event->dateEvent,'',$dateVal);
$form->hourDebut = new basicElement('text','hourDebut','Heure de début : <br />(format hh:mm)',$event->heureDebut,'',$hourVal);
$form->hourFin = new basicElement('text','hourFin','Heure de fin : <br />(format hh:mm)',$event->heureFin,'',$hourVal);
$form->emails = new basicElement('textarea','emails','Courriel à envoyer<br />(séparés par virgule)',$event->emails,'');
$form->submit = new basicElement('submit','connect','','Modifier');

if($form->isSent() && $form->isValid()){
	// check date
	if( substr($_POST['date'],0,2) <= 31 &&
	    substr($_POST['date'],-4) >= date('Y') &&
	    ((int)substr($_POST['date'],3,2) > 0 && substr($_POST['date'],3,2) < 13)){

		$heureDebut = explode(':',$_POST['hourDebut']);
		$heureFin = explode(':',$_POST['hourFin']);
	
		if( $heureDebut[0] >= 0 && $heureDebut[0] < 24 &&
			$heureFin[0] >= 0 	&& $heureFin[0] < 24 &&
			$heureDebut[1] >= 0 && $heureDebut[1] < 60 &&
			$heureFin[1] >= 0 && $heureFin[1] < 60 ){

			// check if debut > fin
			$hourDebut = (int)((substr($_POST['hourDebut'],0,2) * 60) + substr($_POST['hourDebut'],-2));
			$hourFin = (int)((substr($_POST['hourFin'],0,2)) * 60 + substr($_POST['hourFin'],-2));
			if($hourDebut < $hourFin){
				
				// Parse emails
				$oldEmails = explode(',', $event->emails);
				
				$emailAddresses = explode(',', $_POST['emails']);
				foreach($emailAddresses as $k => $emailAddress){
					if($email->validate(trim($emailAddress)) == false)
						unset($emailAddresses[$k]);
					elseif(in_array($emailAddress, $oldEmails))
						unset($emailAddresses[$k]);
					else
						$emailAddresses[$k] = trim($emailAddress);
				}
				
				// saving the old email addresses
				$savingEmails = array();
				foreach($oldEmails as $oldEmail)
					$savingEmails[] = $oldEmail;
				foreach($emailAddresses as $emailAddress)
					$savingEmails[] = $emailAddress;
									
				// New event
				$newEvent = new event($dbh);
				$newEvent = $newEvent->findById($_POST['id']);
				$newEvent->add(array(
					'titre'=>$_POST['title'],
					'description'=>$_POST['desc'],
					'dateEvent'=>$_POST['date'],
					'heureDebut'=>$_POST['hourDebut'],
					'heureFin'=>$_POST['hourFin'],
					'userId'=>$_SESSION['userId'],
					'emails'=>implode(',',$savingEmails)
				));
				
				// Sending emails
				/*
				$message = $_SESSION['userName'].' <'.$_SESSION['userEmail'].'> vous annonce

Événement : '.$_POST['titre'].
'Le '.$_POST['date'].' de '.$_POST['hourDebut'].' à '.$_POST['hourFin'].'

'.$_POST['desc'];

				if($_SMTP['enable_custom_smtp'] === true){
					unset($_SMTP['enable_custom_smtp']);
					$emailSender = new smtp($_SMTP);
					
					foreach($emailAddresses as $emailAddress)
						$emailSender->mail($_SESSION['userEmail'], $emailAddress, 'Nouvel événement : '.$_POST['titre'], $message);
				} else {
					foreach($emailAddresses as $emailAddress)
						mail($emailAddress, 'Nouvel événement : '.$_POST['title'], $message);
				}
				*/
				
				// Saving event				
				$newEvent->save();			
				
				// Displaying Confirmation
				echo <<< END
Événement modifié<br />\n
<a href="index.php?page=calendar">Retourner au calendrier</a><br /><br />\n
END;
				if(count($emailAddresses) > 0){
					echo "<br />Courriel(s) envoyé(s) à :<br />\n";
					foreach($emailAddresses as $emailAddress)
						echo "$emailAddress<br />\n";
					echo '<br />';
				}
			}
			// HourFin is lesser than HourDebut
			else{
				echo '<center><h3>Nouvel événement</h3></center>',
					 '<div class="formError">L\'heure de fin de l\'événement doit être plus grande que l\'heure du début</div>';
				$form->show();
			}
		}
		// Invalid hours format
		else{
			echo '<center><h3>Modification d\'événement</h3></center>',
				 '<div class="formError">Veuillez entrer un format valide d\'heure de début et de fin au format HH:MM</div>';
			$form->show();
		}
	}
	// Invalid date format
	else{
		echo '<center><h3>Modification d\'événement</h3></center>',
			 '<div class="formError">Veuillez entrer une date au format JJ-MM-AAAA valide.</div>';
		$form->show();	
	}
}
// Displaying the form
else{
	echo '<center><h3>Modification d\'événement</h3></center>';
	$form->show();
}

/****************************************/	
		
	}
	else
		echo '<h3><center>Aucun événement trouvé.</center></h3>';
	
} else {
		echo '<h3><center>Aucun événement trouvé.</center></h3>';	
}
?>
